6 # Build LLVM the "Apple way".
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
28 # The fifth parameter is the place where the compiler will be copied once it's
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
49 # A yes/no parameter that controls whether to cross-build for an ARM host.
50 ARM_HOSTED_BUILD="${10}"
52 # A yes/no parameter that controls whether to cross-build for the iOS simulator
55 # The version number of the submission, e.g. 1007.
56 LLVM_SUBMIT_VERSION="${12}"
58 # The subversion number of the submission, e.g. 03.
59 LLVM_SUBMIT_SUBVERSION="${13}"
61 # The current working directory is where the build will happen. It may already
62 # contain a partial result of an interrupted build, in which case this script
63 # will continue where it left off.
66 DARWIN_VERS=`uname -r | sed 's/\..*//'`
67 echo DARWIN_VERS = $DARWIN_VERS
69 ################################################################################
72 # Create the source tree we'll actually use to build, deleting
73 # tcl since it doesn't actually build properly in a cross environment
74 # and we don't really need it.
76 rm -rf $SRC_DIR || exit 1
77 mkdir $SRC_DIR || exit 1
78 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
79 # We can't use the top-level Makefile as-is. Remove the soft link:
80 rm $SRC_DIR/Makefile || exit 1
81 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
82 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
84 # Build the LLVM tree universal.
85 mkdir -p $DIR/obj-llvm || exit 1
86 cd $DIR/obj-llvm || exit 1
88 if [ "$ARM_HOSTED_BUILD" = yes ]; then
89 # The cross-tools' build process expects to find an existing cross toolchain
90 # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
91 rm -rf $DIR/bin || exit 1
92 mkdir $DIR/bin || exit 1
93 for prog in ar nm ranlib strip lipo ld as ; do
94 P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
95 T=`xcrun -sdk $SDKROOT -find ${prog}`
96 echo '#!/bin/sh' > $P || exit 1
97 echo 'exec '$T' "$@"' >> $P || exit 1
98 chmod a+x $P || exit 1
100 # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
101 for prog in gcc g++ ; do
102 P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
103 T=`xcrun -sdk $SDKROOT -find llvm-${prog}`
104 if [ "x$T" = "x" ] ; then
105 T=`xcrun -sdk $SDKROOT -find ${prog}`
107 echo '#!/bin/sh' > $P || exit 1
108 echo 'exec '$T' -arch armv6 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
109 chmod a+x $P || exit 1
113 # otherwise, try to use llvm-gcc if it's available
114 elif [ $DARWIN_VERS -gt 9 ]; then
115 # If the user has set CC or CXX, respect their wishes. If not,
116 # compile with LLVM-GCC/LLVM-G++ if available; if LLVM is not
117 # available, fall back to usual GCC/G++ default.
118 savedPATH=$PATH ; PATH="/Developer/usr/bin:$PATH"
119 XTMPCC=$(which llvm-gcc)
120 if [ x$CC = x -a x$XTMPCC != x ] ; then export CC=$XTMPCC ; fi
121 XTMPCC=$(which llvm-g++)
122 if [ x$CXX = x -a x$XTMPCC != x ] ; then export CXX=$XTMPCC ; fi
124 unset XTMPCC savedPATH
127 if [ "$ARM_HOSTED_BUILD" = yes ]; then
128 configure_opts="--enable-targets=arm --host=arm-apple-darwin10 \
129 --target=arm-apple-darwin10 --build=i686-apple-darwin10"
130 elif [ "$IOS_SIM_BUILD" = yes ]; then
131 # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
132 configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
133 --build=i686-apple-darwin10"
135 configure_opts="--enable-targets=arm,x86,powerpc,cbe"
138 if [ \! -f Makefile.config ]; then
139 $SRC_DIR/configure --prefix=$DEST_DIR$DEST_ROOT $configure_opts \
140 --enable-assertions=$LLVM_ASSERTIONS \
141 --enable-optimized=$LLVM_OPTIMIZED \
146 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
148 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
149 LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
150 RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
151 LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
154 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
155 LLVM_VERSION="$LLVM_SUBMIT_VERSION"
157 LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
160 GCC_VER=`cc --version 2>/dev/null | sed 1q`
162 if echo "$GCC_VER" | grep GCC > /dev/null; then
163 GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
164 MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
165 MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
170 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
171 # already has parallelism and we don't want to make the builders hit swap by
172 # firing off too many gccs at the same time.
173 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
174 # Figure out how many make processes to run.
175 SYSCTL=`sysctl -n hw.activecpu`
177 # hw.activecpu only available in 10.2.6 and later
178 if [ -z "$SYSCTL" ]; then
179 SYSCTL=`sysctl -n hw.ncpu`
182 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
183 # Builders can default to 2, since even if they are single processor,
184 # nothing else is running on the machine.
185 if [ -z "$SYSCTL" ]; then
189 JOBS_FLAG="-j $SYSCTL"
192 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
193 UNIVERSAL_SDK_PATH=$SDKROOT \
197 LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
198 LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
199 CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
202 if [ $? != 0 ] ; then
203 echo "error: LLVM 'make' failed!"
207 ################################################################################
208 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
209 # $DEST_DIR, with occasional 'lipo' commands.
211 cd $DEST_DIR || exit 1
213 # Clean out DEST_DIR in case -noclean was passed to buildit.
216 cd $DIR/obj-llvm || exit 1
218 # Install the tree into the destination directory.
219 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
223 LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
224 LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
225 OPTIMIZE_OPTION='-O3' VERBOSE=1 install
227 if ! test $? == 0 ; then
228 echo "error: LLVM 'make install' failed!"
233 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
234 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
237 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
238 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
239 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
241 if [ "x$LLVM_DEBUG" != "x1" ]; then
242 # Strip local symbols from llvm libraries.
244 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
246 strip -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
247 for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
252 # Copy over the tblgen utility.
253 cp `find $DIR -name tblgen` $DEST_DIR$DEST_ROOT/bin
256 cd $DEST_DIR$DEST_ROOT
257 rm -f bin/.dir etc/llvm/.dir lib/.dir
259 # Remove PPC64 fat slices.
260 cd $DEST_DIR$DEST_ROOT/bin
261 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
262 find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
263 -exec lipo -extract ppc -extract i386 {} -output {} \;
264 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
265 find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
266 -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
268 find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
269 -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
272 # The Hello dylib is an example of how to build a pass.
273 # The BugpointPasses module is only used to test bugpoint.
274 # These unversioned dylibs cause verification failures, so do not install them.
275 rm $DEST_DIR$DEST_ROOT/lib/libLLVMHello.dylib
276 rm $DEST_DIR$DEST_ROOT/lib/libBugpointPasses.dylib
279 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
282 ################################################################################
283 # Create SYM_DIR with information required for debugging.
285 # Figure out how many make processes to run.
286 SYSCTL=`sysctl -n hw.activecpu`
288 # hw.activecpu only available in 10.2.6 and later
289 if [ -z "$SYSCTL" ]; then
290 SYSCTL=`sysctl -n hw.ncpu`
293 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
294 # can default to 2, since even if they are single processor, nothing else is
295 # running on the machine.
296 if [ -z "$SYSCTL" ]; then
300 cd $SYM_DIR || exit 1
302 # Clean out SYM_DIR in case -noclean was passed to buildit.
305 # Generate .dSYM files
306 find $DEST_DIR -perm -0111 -type f \
307 ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
308 -print | xargs -n 1 -P ${SYSCTL} dsymutil
310 # Save .dSYM files and .a archives
311 cd $DEST_DIR || exit 1
312 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
313 | cpio -pdml $SYM_DIR || exit 1
316 mkdir $SYM_DIR/src || exit 1
318 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
319 | cpio -pdml $SYM_DIR/src || exit 1
321 ################################################################################
322 # Install and strip libLTO.dylib
324 cd $DEST_DIR$DEST_ROOT
325 if [ "$INSTALL_LIBLTO" = "yes" ]; then
326 DT_HOME="$DEST_DIR/Developer/usr"
327 mkdir -p $DT_HOME/lib
328 mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
330 # Save a copy of the unstripped dylib
331 mkdir -p $SYM_DIR/Developer/usr/lib
332 cp $DT_HOME/lib/libLTO.dylib $SYM_DIR/Developer/usr/lib/libLTO.dylib
334 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
336 strip -arch all -Sl $DT_HOME/lib/libLTO.dylib
338 if [ "x$DISABLE_USR_LINKS" == "x" ]; then
339 # Add a symlink in /usr/lib for B&I.
340 mkdir -p $DEST_DIR/usr/lib/
341 (cd $DEST_DIR/usr/lib && \
342 ln -s ../../Developer/usr/lib/libLTO.dylib ./libLTO.dylib)
345 rm -f lib/libLTO.dylib
347 rm -f lib/libLTO.a lib/libLTO.la
349 ################################################################################
350 # Remove debugging information from DEST_DIR.
354 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
355 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
357 # Strip debugging information from files
359 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
361 find $DEST_DIR -perm -0111 -type f \
362 ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
363 -print | xargs -n 1 -P ${SYSCTL} strip -arch all -Sl
365 chgrp -h -R wheel $DEST_DIR
366 chgrp -R wheel $DEST_DIR
368 ################################################################################
369 # Remove the docs directory
371 rm -rf $DEST_DIR$DEST_ROOT/docs
373 ################################################################################